<?php

/**
 * Size guide import - WooCommerce Product CSV Import Suite
 */
class bwdpsgxSizeGuideProductCsvImport
{
	/**
	 * bwdpsgx_SizeGuideProductCsvImport constructor
	 */
	public function __construct()
    {
	    // export
	    add_filter('woocommerce_csv_product_post_columns', array($this, 'filterCsvProductPostColumns'));

	    // import
	    add_filter('woocommerce_csv_product_postmeta_defaults', array($this, 'filterCsvProductPostmetaDefaults'));
    }

	/**
	 * @param $columns
	 *
	 * @return mixed
	 */
	public function filterCsvProductPostColumns( $columns )
    {
	    // adds "_bwdpsgx_selectsizeguide" column key to be searched for
	    // "meta:_bwdpsgx_selectsizeguide" is desired column key in output file
	    $columns['_bwdpsgx_selectsizeguide'] = 'meta:_bwdpsgx_selectsizeguide';
	    return $columns;
    }

	/**
	 * @param $postmeta
	 */
	public function filterCsvProductPostmetaDefaults( $postmeta )
	{
		// adds "bwdpsgx_selectsizeguide" key to be searched for
		$postmeta['_bwdpsgx_selectsizeguide'] =  '';
    }
}

new bwdpsgxSizeGuideProductCsvImport();