<?php

class bwdpsgxSizeGuideProducts {

	/**
	 * Inits object
	 */

	public function __construct() {
		add_action( 'add_meta_boxes', array( $this, 'chooseProducts' ) );
		add_action( 'save_post_bwdpsgx_size_guide', array( $this, 'saveSizeGuideProducts' ) );
	}

	/**
	 * Register metabox
	 */

	public function chooseProducts() {
		add_meta_box( 'bwdpsgx_sizeguideopt_products', __( 'Choose products', 'bwdpsgx-custom-size' ), array(
			$this,
			'renderSizeGuideProducts'
		), 'bwdpsgx_size_guide', 'side' );
	}



	/**
	 * Render categoriers
	 *
	 * @param $post
	 */

	public function renderSizeGuideProducts( $post ) {
        $sizeGuideId = $post->ID;
		$args = [
            "post_type" => "product",
            "posts_per_page" => -1,
        ];
        $productsQuery = new WP_Query($args);
        if (!$productsQuery->have_posts()) {
            return;
        }
        
		$assignedProducts = $this->getSelectedProducts($sizeGuideId);
        if (!isset($assignedProducts) || !is_array($assignedProducts)) {
            $assignedProducts = [];
        }
        bwdpsgxSizeGuideAdmin::appendSearch();

        echo '<div class="bwdpsgx-custom-size-checkboxes">';
		foreach ( $productsQuery->posts as $product ) {
            if (!$product instanceof WP_Post) {
                continue;
            }
			$checked = false;
			if ( is_array($assignedProducts) && in_array( $product->ID, $assignedProducts ) ) {
				$checked = ' checked';
			}
			echo '<div class="bwdpsgx-custom-size-checkbox">';
            echo '<input class="bwdpsgx-custom-size-checkbox__input" type="checkbox" name="bwdpsgx_sg_prods[]" value="' . esc_attr($product->ID) . '"' . $checked . ' />';
            echo '<span class="bwdpsgx-custom-size-checkbox__name">'. sanitize_text_field($product->post_title) . '</span>';
			echo '</div>';

		}
        echo '</div>';

	}

    public function getSelectedProducts($sizeGuideId) {
        if (!is_numeric($sizeGuideId)) {
            return [];
        }
        $queryArgs = [
            'post_type' => 'product',
            "posts_per_page" => -1,
            "fields" => "ids",
            "meta_query" => [
                [
                    "key" => "_bwdpsgx_selectsizeguide",
                    "value" => $sizeGuideId
                ]

            ]
        ];
        $query = new WP_Query($queryArgs);
        if (!$query->have_posts()) {
            return [];
        }
        return $query->posts;

    }
	/**
	 * Save categories
	 *
	 * @param $sizeGuideId
	 */

	public function saveSizeGuideProducts( $sizeGuideId ) {
        if (!is_numeric($sizeGuideId)) {
            return;
        }
		$selectedProducts = (isset($_POST['bwdpsgx_sg_prods']) && is_array($_POST['bwdpsgx_sg_prods'])) ? $_POST['bwdpsgx_sg_prods'] : [];
        if (!count($selectedProducts) > 0) {
            return;
        }
        $oldSelectedProducts = $this->getSelectedProducts($sizeGuideId);
        foreach ($oldSelectedProducts as $productId) {
            if (!is_numeric($productId)) {
                continue;
            }
            delete_post_meta($productId, '_bwdpsgx_selectsizeguide');
        }

        foreach ($selectedProducts as $productId) {
            if (!is_numeric($productId)) {
                continue;
            }
            update_post_meta($productId, '_bwdpsgx_selectsizeguide', $sizeGuideId);
        }
    }

}

new bwdpsgxSizeGuideProducts();